#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "include/main.h"
#include "include/card.h"

void die(char *s) {
    fprintf(stderr, "fatal: %s\n", s);
    exit(1);
}

char *fgetl(FILE *stream) {
    size_t s_sz = 1; // +1 for null byte
    char *s = NULL;
    char c;

    while ((c = fgetc(stream)) != '\n') {
        if (c == EOF)
            return NULL;

        s = (char *)realloc((void *)s, ++s_sz);
        s[s_sz - 2] = c;
    }

    if (s != NULL)
        s[s_sz - 1] = '\0';

    return s;
}

char *strdup_(char *s) {
    char *r;
    r = (char *)malloc(strlen(s) + 1);
    strcpy(r, s);
    return r;
}

int main(int argc, char **argv) {
    CARD *cards;
    size_t cards_ct;

    if (argc < 1)
        die("filename required");

    cards = card_parse_csv(argv[1], &cards_ct);

    for (size_t i = 0; i < cards_ct; i++)
        printf("o: `%s`, r: `%s`\n", cards[i].obverse, cards[i].reverse);

    return 0;
}
